/* StatServ core functions
 *
 * (C) 2003-2010 Anope Team
 * Contact us at team@anope.org
 *
 * Please read COPYING and README for further details.
 *
 * Based on the original code of Epona by Lara.
 * Based on the original code of Services by Andy Church.
 *
 * $Id: ss_main.c 2933 2010-05-05 23:09:14Z pimpmylinux $
 *
 */

#include "module.h"

BotInfo *statserv = NULL;
CommandHash *cmdTable[MAX_CMD_HASH];

class CommandSSHelp : public Command
{
 public:
	CommandSSHelp() : Command("HELP", 0, 0)
	{
	}

	CommandReturn Execute(User *u, const std::vector<ci::string> &params)
	{
		ircdproto->SendMessage(statserv, u->nick.c_str(), "This is a test of the emergency StatServ system.");
		return MOD_CONT;
	}
};

class SSMain : public Module
{
 public:
	SSMain(const std::string &modname, const std::string &creator) : Module(modname, creator)
	{
		this->SetAuthor("Anope");
		this->SetVersion("$Id: ss_main.c 2933 2010-05-05 23:09:14Z pimpmylinux $");
		this->SetType(CORE);
		this->SetPermanent(true);

		this->AddCommand(cmdTable, new CommandSSHelp());

		statserv = findbot("StatServ");
		if (!statserv)
		{
			Alog() << "Creating SS";
			statserv = new BotInfo("StatServ", Config.ServiceUser, Config.ServiceHost, "Stats Service");
		}
		Alog() << "Done creating SS";
		statserv->cmdTable = cmdTable;
	}

	~SSMain()
	{
		CommandHash *current;
		Command *c;
		for (int i = 0; i < MAX_CMD_HASH; ++i)
		{
			for (current = cmdTable[i]; current; current = current->next)
			{
				for (c = current->c; c; c = c->next)
					this->DelCommand(cmdTable, c->name.c_str());
			}
		}
		if (statserv)
		{
			ircdproto->SendQuit(statserv, "Quit due to module unload.");
			delete statserv;
		}
	}
};

MODULE_INIT(SSMain)
